//#line 2 "/opt/ros/melodic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the teraranger package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __teraranger__EVOTHERMALCONFIG_H__
#define __teraranger__EVOTHERMALCONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace teraranger
{
  class EvoThermalConfigStatics;

  class EvoThermalConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }

      virtual void clamp(EvoThermalConfig &config, const EvoThermalConfig &max, const EvoThermalConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const EvoThermalConfig &config1, const EvoThermalConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, EvoThermalConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const EvoThermalConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, EvoThermalConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const EvoThermalConfig &config) const = 0;
      virtual void getValue(const EvoThermalConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T EvoThermalConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T EvoThermalConfig::* field;

      virtual void clamp(EvoThermalConfig &config, const EvoThermalConfig &max, const EvoThermalConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const EvoThermalConfig &config1, const EvoThermalConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, EvoThermalConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const EvoThermalConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, EvoThermalConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const EvoThermalConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const EvoThermalConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, EvoThermalConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, EvoThermalConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T PT::* field;
      std::vector<EvoThermalConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(EvoThermalConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("thermal_image_flip_h"==(*_i)->name){thermal_image_flip_h = boost::any_cast<bool>(val);}
        if("thermal_image_flip_v"==(*_i)->name){thermal_image_flip_v = boost::any_cast<bool>(val);}
        if("thermal_image_interpolate"==(*_i)->name){thermal_image_interpolate = boost::any_cast<bool>(val);}
        if("thermal_image_autoscale"==(*_i)->name){thermal_image_autoscale = boost::any_cast<bool>(val);}
        if("manual_min_scaling"==(*_i)->name){manual_min_scaling = boost::any_cast<double>(val);}
        if("manual_max_scaling"==(*_i)->name){manual_max_scaling = boost::any_cast<double>(val);}
        if("Map"==(*_i)->name){Map = boost::any_cast<int>(val);}
      }
    }

    bool thermal_image_flip_h;
bool thermal_image_flip_v;
bool thermal_image_interpolate;
bool thermal_image_autoscale;
double manual_min_scaling;
double manual_max_scaling;
int Map;

    bool state;
    std::string name;

    
}groups;



//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool thermal_image_flip_h;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool thermal_image_flip_v;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool thermal_image_interpolate;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool thermal_image_autoscale;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double manual_min_scaling;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double manual_max_scaling;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int Map;
//#line 228 "/opt/ros/melodic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("EvoThermalConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const EvoThermalConfig &__max__ = __getMax__();
      const EvoThermalConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const EvoThermalConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const EvoThermalConfig &__getDefault__();
    static const EvoThermalConfig &__getMax__();
    static const EvoThermalConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const EvoThermalConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void EvoThermalConfig::ParamDescription<std::string>::clamp(EvoThermalConfig &config, const EvoThermalConfig &max, const EvoThermalConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class EvoThermalConfigStatics
  {
    friend class EvoThermalConfig;

    EvoThermalConfigStatics()
    {
EvoThermalConfig::GroupDescription<EvoThermalConfig::DEFAULT, EvoThermalConfig> Default("Default", "", 0, 0, true, &EvoThermalConfig::groups);
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.thermal_image_flip_h = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.thermal_image_flip_h = 1;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.thermal_image_flip_h = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<bool>("thermal_image_flip_h", "bool", 0, "Flip Thermal Image horizontally", "", &EvoThermalConfig::thermal_image_flip_h)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<bool>("thermal_image_flip_h", "bool", 0, "Flip Thermal Image horizontally", "", &EvoThermalConfig::thermal_image_flip_h)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.thermal_image_flip_v = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.thermal_image_flip_v = 1;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.thermal_image_flip_v = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<bool>("thermal_image_flip_v", "bool", 0, "Flip Thermal Image vertically", "", &EvoThermalConfig::thermal_image_flip_v)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<bool>("thermal_image_flip_v", "bool", 0, "Flip Thermal Image vertically", "", &EvoThermalConfig::thermal_image_flip_v)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.thermal_image_interpolate = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.thermal_image_interpolate = 1;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.thermal_image_interpolate = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<bool>("thermal_image_interpolate", "bool", 0, "Interpolate Thermal Image", "", &EvoThermalConfig::thermal_image_interpolate)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<bool>("thermal_image_interpolate", "bool", 0, "Interpolate Thermal Image", "", &EvoThermalConfig::thermal_image_interpolate)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.thermal_image_autoscale = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.thermal_image_autoscale = 1;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.thermal_image_autoscale = 1;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<bool>("thermal_image_autoscale", "bool", 1, "Autoscale Thermal Image", "", &EvoThermalConfig::thermal_image_autoscale)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<bool>("thermal_image_autoscale", "bool", 1, "Autoscale Thermal Image", "", &EvoThermalConfig::thermal_image_autoscale)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.manual_min_scaling = 0.0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.manual_min_scaling = 1000.0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.manual_min_scaling = -20.0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<double>("manual_min_scaling", "double", 2, "Lower scaling bound", "", &EvoThermalConfig::manual_min_scaling)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<double>("manual_min_scaling", "double", 2, "Lower scaling bound", "", &EvoThermalConfig::manual_min_scaling)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.manual_max_scaling = 0.0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.manual_max_scaling = 1000.0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.manual_max_scaling = -20.0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<double>("manual_max_scaling", "double", 2, "Upper scaling bound", "", &EvoThermalConfig::manual_max_scaling)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<double>("manual_max_scaling", "double", 2, "Upper scaling bound", "", &EvoThermalConfig::manual_max_scaling)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.Map = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.Map = 4;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.Map = 0;
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<int>("Map", "int", 3, "Set the sensor mode", "{'enum_description': 'Set the colormap for RGB image topic', 'enum': [{'srcline': 15, 'description': 'Set colormap to Dave', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Dave'}, {'srcline': 16, 'description': 'Set colormap to Ice', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Ice'}, {'srcline': 17, 'description': 'Set colormap to Ironbow', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'Ironbow'}, {'srcline': 18, 'description': 'Set colormap to High_contrast', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'High_contrast'}, {'srcline': 19, 'description': 'Set colormap to Whot', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'Whot'}]}", &EvoThermalConfig::Map)));
//#line 291 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(EvoThermalConfig::AbstractParamDescriptionConstPtr(new EvoThermalConfig::ParamDescription<int>("Map", "int", 3, "Set the sensor mode", "{'enum_description': 'Set the colormap for RGB image topic', 'enum': [{'srcline': 15, 'description': 'Set colormap to Dave', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Dave'}, {'srcline': 16, 'description': 'Set colormap to Ice', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Ice'}, {'srcline': 17, 'description': 'Set colormap to Ironbow', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'Ironbow'}, {'srcline': 18, 'description': 'Set colormap to High_contrast', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'High_contrast'}, {'srcline': 19, 'description': 'Set colormap to Whot', 'srcfile': '/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'Whot'}]}", &EvoThermalConfig::Map)));
//#line 246 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 246 "/opt/ros/melodic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(EvoThermalConfig::AbstractGroupDescriptionConstPtr(new EvoThermalConfig::GroupDescription<EvoThermalConfig::DEFAULT, EvoThermalConfig>(Default)));
//#line 366 "/opt/ros/melodic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<EvoThermalConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<EvoThermalConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<EvoThermalConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    EvoThermalConfig __max__;
    EvoThermalConfig __min__;
    EvoThermalConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const EvoThermalConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static EvoThermalConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &EvoThermalConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const EvoThermalConfig &EvoThermalConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const EvoThermalConfig &EvoThermalConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const EvoThermalConfig &EvoThermalConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<EvoThermalConfig::AbstractParamDescriptionConstPtr> &EvoThermalConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<EvoThermalConfig::AbstractGroupDescriptionConstPtr> &EvoThermalConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const EvoThermalConfigStatics *EvoThermalConfig::__get_statics__()
  {
    const static EvoThermalConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = EvoThermalConfigStatics::get_instance();

    return statics;
  }

//#line 15 "/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg"
      const int EvoThermal_Dave = 0;
//#line 16 "/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg"
      const int EvoThermal_Ice = 1;
//#line 17 "/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg"
      const int EvoThermal_Ironbow = 2;
//#line 18 "/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg"
      const int EvoThermal_High_contrast = 3;
//#line 19 "/tmp/binarydeb/ros-melodic-teraranger-2.1.0/cfg/EvoThermal.cfg"
      const int EvoThermal_Whot = 4;
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __EVOTHERMALRECONFIGURATOR_H__
